package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.system.domain.SysOss;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.TblEventBo;
import org.dromara.system.domain.vo.TblEventVo;
import org.dromara.system.domain.TblEvent;
import org.dromara.system.mapper.TblEventMapper;
import org.dromara.system.service.ITblEventService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 事件Service业务层处理
 *
 * @author Lion Li
 * @date 2025-06-13
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class TblEventServiceImpl implements ITblEventService {

    private final TblEventMapper baseMapper;

    /**
     * 查询事件
     *
     * @param id 主键
     * @return 事件
     */
    @Override
    public TblEventVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事件列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事件分页列表
     */
    @Override
    public TableDataInfo<TblEventVo> queryPageList(TblEventBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TblEvent> lqw = buildQueryWrapper(bo);
        Page<TblEventVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事件列表
     *
     * @param bo 查询条件
     * @return 事件列表
     */
    @Override
    public List<TblEventVo> queryList(TblEventBo bo) {
        LambdaQueryWrapper<TblEvent> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TblEvent> buildQueryWrapper(TblEventBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TblEvent> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TblEvent::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getAddr()), TblEvent::getAddr, bo.getAddr());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), TblEvent::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getLevel()), TblEvent::getLevel, bo.getLevel());
        lqw.eq(StringUtils.isNotBlank(bo.getProcessingDept()), TblEvent::getProcessingDept, bo.getProcessingDept());
        lqw.eq(StringUtils.isNotBlank(bo.getRecomEvent()), TblEvent::getRecomEvent, bo.getRecomEvent());
        lqw.eq(StringUtils.isNotBlank(bo.getEmergencyPlan()), TblEvent::getEmergencyPlan, bo.getEmergencyPlan());
        lqw.eq(StringUtils.isNotBlank(bo.getExt1()), TblEvent::getExt1, bo.getExt1());
        lqw.eq(StringUtils.isNotBlank(bo.getExt2()), TblEvent::getExt2, bo.getExt2());
        if(params.get("lx")!=null){
            lqw.apply(StringUtils.format(" ext2->'$.lx' like '%{}%'", params.get("lx").toString()));
        }
        if(params.get("key")!=null){
            lqw.apply(StringUtils.format(" ext2->'$.lx' like '%{}%' or addr like '%{}%'", params.get("key").toString(), params.get("key").toString()));
        }
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TblEvent::getCreateTime, params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增事件
     *
     * @param bo 事件
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TblEventBo bo) {
        TblEvent add = MapstructUtils.convert(bo, TblEvent.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事件
     *
     * @param bo 事件
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TblEventBo bo) {
        TblEvent update = MapstructUtils.convert(bo, TblEvent.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TblEvent entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事件信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
